package me.wazup.hideandseek.commands.user;

import me.wazup.hideandseek.Arena;
import me.wazup.hideandseek.managers.TitleManager;
import org.bukkit.Bukkit;
import me.wazup.hideandseek.PlayerData;
import org.bukkit.entity.Player;
import me.wazup.hideandseek.Config;
import org.bukkit.command.CommandSender;
import me.wazup.hideandseek.Customization;
import me.wazup.hideandseek.HideAndSeek;
import me.wazup.hideandseek.commands.SubCommand;

public class LeaveCommand extends SubCommand
{
    public LeaveCommand() {
        super((String)null, false, (String)null);
    }
    
    public boolean execute(final HideAndSeek hideAndSeek, final Customization customization, final CommandSender commandSender, final String[] array) {
        if (Config.getInstance().bungeeEnabled) {
            commandSender.sendMessage((String)customization.messages.get("unknown_command"));
            return true;
        }
        final Player player = (Player)commandSender;
        final Arena arena = hideAndSeek.playerData.get(player.getName()).arena;
        if (arena == null) {
            player.sendMessage((String)customization.messages.get("not_in_game"));
            return true;
        }
        hideAndSeek.game.remove(player.getName());
        if (arena.spectators.contains(player.getName())) {
            final PlayerData playerData = hideAndSeek.playerData.get(player.getName());
            player.setGameMode(playerData.gameMode);
            player.teleport(playerData.location);
            if (playerData.flying) {
                player.setAllowFlight(true);
                player.setFlying(true);
            }
            player.addPotionEffects(playerData.effects);
            player.setScoreboard(Bukkit.getScoreboardManager().getNewScoreboard());
            arena.spectators.remove(player.getName());
            playerData.destroyData();
            return true;
        }
        hideAndSeek.grace.remove(player.getName());
        ((PlayerData)hideAndSeek.playerData.get(player.getName())).restoreData(player);
        arena.leave(player);
        player.setFireTicks(0);
        player.sendMessage((String)customization.messages.get("arena_leave"));
        if (hideAndSeek.player_leave_title != null) {
            TitleManager.getInstance().sendTitle(player, hideAndSeek.player_leave_title);
        }
        return true;
    }
}
